#include <Wire.h>
#include <MPU6050.h>
#include <Keyboard.h>
 
MPU6050 mpu;
 
void setup() {
  Wire.begin();
  mpu.initialize();
 
  Serial.begin(9600);
  while (!Serial) {
    // Wait for the serial connection to establish
  }
 
  // Check if the MPU6050 is connected properly
  if (mpu.testConnection()) {
    Serial.println("MPU6050 connected successfully!");
  } else {
    Serial.println("MPU6050 connection failed!");
    while (1); // Halt the program
  }
}
 
void loop() {
  int16_t ax, ay, az;
 
  // Read acceleration values
  mpu.getAcceleration(&ax, &ay, &az);
 
  // Normalize accelerometer values to detect motion direction
  float normAx = ax / 16384.0; // Normalize to g (assuming ±2g sensitivity)
  float normAy = ay / 16384.0;
 
  // Determine direction
  if (normAx > 0.3) {
    Serial.println("Motion detected: RIGHT");
  } else if (normAx < -0.2) {
    Serial.println("Motion detected: LEFT");
  }
 
  if (normAy > 0.2) {
    Serial.println("Motion detected: DOWN");
  } else if (normAy < -0.2) {
    Serial.println("Motion detected: UP");
  }
 
  // Debug: Print raw acceleration values
  Serial.print("Ax: "); Serial.print(normAx);
  Serial.print(" | Ay: "); Serial.print(normAy);
  Serial.print(" | Az: "); Serial.println(az / 16384.0);
 
   if (normAx > 0.3) {
    // Si le mouvement X est positif, envoyer la flèche droite
    Keyboard.press(KEY_RIGHT_ARROW);
  } else if (normAx < -0.3) {
    // Si le mouvement X 3st négatif, envoyer la flèche gauche
    Keyboard.press(KEY_LEFT_ARROW);
  } else {
    // Si aucun mouvement X n'est détecté, relâcher la touche
    Keyboard.release(KEY_LEFT_ARROW);
    Keyboard.release(KEY_RIGHT_ARROW);
  }
 
  if (normAy > 0.2) {
    // Si le mouvement Y est positif, envoyer la flèche bas
    Keyboard.press(KEY_DOWN_ARROW);
  } else if (normAy < -0.2) {
    // Si le mouvement Y est négatif, envoyer la flèche haut
    Keyboard.press(KEY_UP_ARROW);
  } else {
    // Si aucun mouvement Y n'est détecté, relâcher la touche
    Keyboard.release(KEY_UP_ARROW);
    Keyboard.release(KEY_DOWN_ARROW);
  }
 
  delay(100); // Adjust for your desired update frequency
}
 
Le nouveau :
 
#include <Wire.h>
#include <MPU6050.h>
#include <Keyboard.h>
 
MPU6050 mpu;
 
void setup() {
  Wire.begin();
  mpu.initialize();
 
  Serial.begin(9600);
  while (!Serial) {
    // Wait for the serial connection to establish
  }
 
  // Check if the MPU6050 is connected properly
  if (mpu.testConnection()) {
    Serial.println("MPU6050 connected successfully!");
  } else {
    Serial.println("MPU6050 connection failed!");
    while (1); // Halt the program
  }
}
 
void loop() {
  int16_t ax, ay, az;
 
  // Read acceleration values
  mpu.getAcceleration(&ax, &ay, &az);
 
  // Normalize accelerometer values to detect motion direction
  float normAx = ax / 16384.0; // Normalize to g (assuming ±2g sensitivity)
  float normAy = ay / 16384.0;
 
  // Determine direction
  if (normAx > 0.3) {
    Serial.println("Motion detected: RIGHT");
    Keyboard.press(KEY_RIGHT_ARROW);
  } else if (normAx < -0.2) {
    Serial.println("Motion detected: LEFT");
    Keyboard.press(KEY_LEFT_ARROW);
  }
 
  if (normAy > 0.2) {
    Serial.println("Motion detected: DOWN");
    Keyboard.press(KEY_DOWN_ARROW);
  } else if (normAy < -0.2) {
    Serial.println("Motion detected: UP");
    Keyboard.press(KEY_UP_ARROW);
  }
 
  } else {
    // Si aucun mouvement X n'est détecté, relâcher la touche
    Keyboard.release(KEY_LEFT_ARROW);
    Keyboard.release(KEY_RIGHT_ARROW);
    Keyboard.release(KEY_UP_ARROW);
    Keyboard.release(KEY_DOWN_ARROW);
  }
 
  // Debug: Print raw acceleration values
  Serial.print("Ax: "); Serial.print(normAx);
  Serial.print(" | Ay: "); Serial.print(normAy);
  Serial.print(" | Az: "); Serial.println(az / 16384.0);
 
  delay(100); // Adjust for your desired update frequency
}
 